package com.example.photomemoriesgenerator;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ImageDecoder;
import android.graphics.Path;
import android.media.ExifInterface;
import android.media.FaceDetector;
import android.media.Image;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.DocumentsContract;
import android.provider.MediaStore;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.lang.reflect.Array;
import java.util.ArrayList;

//import android.support.v7.app.AppCompatActivity;
import androidx.appcompat.app.AppCompatActivity;
import androidx.loader.content.CursorLoader;

public class MainActivity extends AppCompatActivity {

        private final String ME = "ACTIVITY_MAIN";
        public static ArrayList<photo> parray = new ArrayList<>();
        private Intent myIntent;
        int fileCount = 0;

        @Override
        protected void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            setContentView(R.layout.activity_main);
            uploadpictures();
        }

        public void goToNextActivity(View v) {//go to settings page
            Log.i("here", "in gotonextactivity");
            myIntent=new Intent(this, settings.class);
            this.startActivity(myIntent);
        }

        protected void onStart(){
            super.onStart();
            Log.i(ME, "start");
        }

        protected void onRestart(){
            super.onRestart();
            Log.i(ME, "restart");
        }
        protected void onResume(){
            super.onResume();
            Log.i(ME, "onResume");
        }
        protected void onPause(){
            super.onPause();
            Log.i(ME, "onPause");
        }
        protected void onStop(){
            super.onStop();
            Log.i(ME, "onStop");
        }
        protected void onDestroy(){
            super.onDestroy();
            Log.i(ME, "onDestroy");
        }
    void uploadpictures() {//pull all files from folder and get data for them
        Uri u;
        Log.i("hello", "in upload");
        //all paths should start same way /storage/emulated/0/DCIM/Camera/
        Bitmap bm;
        File directory = new File("/storage/emulated/0/DCIM/Camera/");
        fileCount = directory.list().length;//number of photos in the folder
        String[] larray = new String[fileCount];
        larray = directory.list();//all filenames
        Log.i("hello", "crashes when getting list");


        for (int i = 0; i < fileCount; i++) {
            Log.i("hello", larray[i]);
            u = Uri.fromFile(new File("/storage/emulated/0/DCIM/Camera/" + larray[i]));
            photo p = new photo();
            String path = "/storage/emulated/0/DCIM/Camera/" + larray[i];//path = folder + filename
            p.SetUri(u);
            p.SetPath(path);
            showExif(u, path, p);//get data
            parray.add(p);//add to array
        }

        Log.i("here", "success");
    }
    void showExif (Uri photoUri, String photoPath, photo p){//get all data from photos using filename
        Log.i("hello", "in showexif");
        if (photoUri != null) {

            Log.i("hello", "photopath " + photoPath);


            try {
                Log.i("hello", "in try");
                ExifInterface exifInterface = new ExifInterface(photoPath);


                String exif = "Exif: ";
                exif += "\nIMAGE_LENGTH: " +
                        exifInterface.getAttribute(ExifInterface.TAG_IMAGE_LENGTH);
                exif += "\nIMAGE_WIDTH: " +
                        exifInterface.getAttribute(ExifInterface.TAG_IMAGE_WIDTH);
                exif += "\n DATETIME: " +
                        exifInterface.getAttribute(ExifInterface.TAG_DATETIME);
                 p.SetDate(exifInterface.getAttribute(ExifInterface.TAG_DATETIME));
                exif += "\n TAG_MAKE: " +
                        exifInterface.getAttribute(ExifInterface.TAG_MAKE);
                exif += "\n TAG_MODEL: " +
                        exifInterface.getAttribute(ExifInterface.TAG_MODEL);
                exif += "\n TAG_ORIENTATION: " +
                        exifInterface.getAttribute(ExifInterface.TAG_ORIENTATION);
                exif += "\n TAG_WHITE_BALANCE: " +
                        exifInterface.getAttribute(ExifInterface.TAG_WHITE_BALANCE);
                exif += "\n TAG_FOCAL_LENGTH: " +
                        exifInterface.getAttribute(ExifInterface.TAG_FOCAL_LENGTH);
                exif += "\n TAG_FLASH: " +
                        exifInterface.getAttribute(ExifInterface.TAG_FLASH);
                exif += "\nGPS related:";
                exif += "\n TAG_GPS_DATESTAMP: " +
                        exifInterface.getAttribute(ExifInterface.TAG_GPS_DATESTAMP);
                exif += "\n TAG_GPS_TIMESTAMP: " +
                        exifInterface.getAttribute(ExifInterface.TAG_GPS_TIMESTAMP);
                exif += "\n TAG_GPS_LATITUDE: " +
                        exifInterface.getAttribute(ExifInterface.TAG_GPS_LATITUDE);
                exif += "\n TAG_GPS_LATITUDE_REF: " +
                        exifInterface.getAttribute(ExifInterface.TAG_GPS_LATITUDE_REF);
                exif += "\n TAG_GPS_LONGITUDE: " +
                        exifInterface.getAttribute(ExifInterface.TAG_GPS_LONGITUDE);
                exif += "\n TAG_GPS_LONGITUDE_REF: " +
                        exifInterface.getAttribute(ExifInterface.TAG_GPS_LONGITUDE_REF);
                exif += "\n TAG_GPS_PROCESSING_METHOD: " +
                        exifInterface.getAttribute(ExifInterface.TAG_GPS_PROCESSING_METHOD);
                float[] latLong = new float[2];
                boolean hasLatLong = exifInterface.getLatLong(latLong);
                if (hasLatLong) {
                    String lat = Float.toString(latLong[0]);
                    String lng = Float.toString(latLong[1]);
                    exif += "\n Actual Lat " + lat;
                    exif += "\n Actual Long " + lng;
                    System.out.println("Latitude: " + latLong[0]);
                    System.out.println("Longitude: " + latLong[1]);
                }

                facedetector(p);
                Log.i("hello", exif);


            } catch (FileNotFoundException e) {
                e.printStackTrace();
                Toast.makeText(getApplicationContext(),
                        "Something wrong:\n" + e.toString(),
                        Toast.LENGTH_LONG).show();
                Log.i("hello", "exception " + e.toString());
            } catch (IOException e) {
                e.printStackTrace();
                Toast.makeText(getApplicationContext(),
                        "Something wrong:\n" + e.toString(),
                        Toast.LENGTH_LONG).show();
            }

        } else {
            Toast.makeText(getApplicationContext(),
                    "photoUri == null",
                    Toast.LENGTH_LONG).show();
        }
        //add all elements so you just check in settings

    }
    void facedetector(photo p) {//looks at each photo to see if there is a face in it, got from android developer website
        Bitmap bm;

            try {
                bm = BitmapFactory.decodeStream(
                        getContentResolver()
                                .openInputStream(p.GetUri()));
            } catch (FileNotFoundException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
                return;

            }
            BitmapFactory.Options bitmapFatoryOptions = new BitmapFactory.Options();
            bitmapFatoryOptions.inPreferredConfig = Bitmap.Config.RGB_565;
            Bitmap bitmap565 = bm.copy(Bitmap.Config.RGB_565, false);

            int h = bitmap565.getHeight();
            int w = bitmap565.getWidth();
            int max = 1;

            FaceDetector detector = new FaceDetector(w, h, max);//looks for certain number of faces in certain width and height of bitmap
            FaceDetector.Face[] f = new FaceDetector.Face[max];
            Log.i("here", "in function");
            int facesFound = detector.findFaces(bitmap565, f);//search bitmap for faces
            Log.i("here", facesFound + "in function");
            if (facesFound > 0) {
                p.SetFaceDetection(true);//if there is at least one face found, add to array
                Log.i("here", "faces works");
            }
            else
                p.SetFaceDetection(false);

        return;
    }
    }

