package com.example.photomemoriesgenerator;

import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;
import static android.media.MediaRecorder.VideoSource.CAMERA;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Path;
import android.net.Uri;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.TimeUnit;

//import android.support.v7.app.AppCompatActivity;
import androidx.appcompat.app.AppCompatActivity;
import androidx.loader.content.CursorLoader;


public class ShowAlbum extends AppCompatActivity {
    ImageView imageView;
    ImageView show;
    Button next;
    Button previous;
    ArrayList<photo> act;
    int counter = 0;
    Button delete;
    public final String ME = "ALBUM_SHOW";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.album_show);
        act = settings.actual;
        show = findViewById(R.id.showimage);
        next = findViewById(R.id.next);
        previous = findViewById(R.id.previous);
        delete = findViewById(R.id.delete);

        ShowArray(act,counter);
        next.setOnClickListener(new View.OnClickListener() {//if next is clicked
            @Override
            public void onClick(View view) {
                if (counter < settings.actual.size() - 1)//check to see if counter is less than arraylist length
                {
                    counter++;
                    ShowArray(act, counter);
                }

            }
        });


        previous.setOnClickListener(new View.OnClickListener() {//if previous is clicked
            @Override
            public void onClick(View view) {
                if (counter > 0)//check to see if counter is greater than 0 than arraylist length
                {
                    counter = counter - 1;
                    ShowArray(act, counter);
                }

            }
        });
        delete.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
             Delete(act, counter);

            }
        });
    }

    public void goBack(View v) {
        this.finish();
    }

    protected void onStart() {
        super.onStart();
        Log.i(ME, "onStart");
    }

    protected void onRestart() {
        super.onRestart();
        Log.i(ME, "onRestart");
    }

    protected void onResume() {
        super.onResume();
        Log.i(ME, "onResume");
    }

    protected void onPause() {
        super.onPause();
        Log.i(ME, "onPause");
    }

    protected void onStop() {
        super.onStop();
        Log.i(ME, "onStop");
    }

    protected void onDestroy() {
        super.onDestroy();
        Log.i(ME, "onDestroy");
    }



        void ShowArray (ArrayList < photo > a ,int count)//set the bitmap for the photo currently selected in the array
        {
            if (a.size() == 0)
                return;
            Bitmap bm;
            show.setImageBitmap(null);
                try {
                    bm = BitmapFactory.decodeStream(
                            getContentResolver()
                                    .openInputStream(a.get(count).GetUri()));//get bitmap using uri
                    show.setImageBitmap(bm);//set bitmap
                } catch (FileNotFoundException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();

                }

            return;
        }

    void Delete(ArrayList<photo> a, int count)//delete the photo from the array and change bitmap to new photo
    {
        if(a.size()==1) {//if only one thing in array
            a.remove(0);
            count = -1;
            Bitmap bm;
            imageView.setImageBitmap(null);
            try {
                bm = BitmapFactory.decodeStream(
                        getContentResolver()
                                .openInputStream(a.get(count).GetUri()));
                show.setImageBitmap(null);
            } catch (FileNotFoundException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();

            }
        }
        else if(count == a.size()-1)//if photo is last in array make the photo seen the one before it
        {
            a.remove(count);
            count=count-1;
            ShowArray(a,count);

        }
        else if(count>=0)//make photo seen the next one in array
        {
            a.remove(count);
            Bitmap bm;
            ShowArray(a, count);

        }

    }


}

